﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading;
namespace Monkee.Core.Utilities
{
    public class RechargeTimer
    {
        public int timeLeft { get; set; }
        private System.Timers.Timer timer;
        public int rechargeTime;
        public int charges { get; set; }
        public int maxCharges { get; set; }
        public bool IsStarted { get; set; }
        public RechargeTimer (int milliseconds, int charges, int maxcharges, bool start = false){
        
            this.rechargeTime = milliseconds;
            this.maxCharges = maxcharges;
            this.charges = charges;
            this.timer = new  System.Timers.Timer();
            timer.Interval = 1000;
            timer.Elapsed += timer_Elapsed;
            if (start)
                this.Start();
        }

        void timer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            timeLeft -= 1000;
            if (timeLeft <= 0)
            {
                timer.Stop();
                IsStarted = false;
                charges++;
                if (charges < maxCharges)
                {
                    Start();
                }
            }
        }

        public void Start() {
            if (!IsStarted)
            {
                Reset();
                timer.Start();
                IsStarted = true;
            }
        }

        public void Reset() {
            timer.Stop();
            timeLeft = rechargeTime;
            
        }
    }
}
