﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Monkee.Interface.GUI
{
    public partial class frmSEFBlacklist : Form
    {
        int currentId = 0;
        
        public frmSEFBlacklist()
        {
            InitializeComponent();
            
            Main.Settings.listSEFBlacklist.ForEach(e => lstBlacklist.Items.Add(e));
            if (lstBlacklist.Items.Count == 0)
                bttnRmv.Enabled = false;
        }

        private void bttnAdd_Click(object sender, EventArgs e)
        {
            if (IsNPCIdValid() && currentId!=0)
            {
                lstBlacklist.Items.Add(currentId);
                Main.Settings.listSEFBlacklist.Add(currentId);
                Main.Settings.SEFBlacklist = Main.Settings.listSEFBlacklist.ToArray();
                Main.Settings.Save();
            }
            else
                MessageBox.Show("Wrong input format.","Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            if (lstBlacklist.Items.Count > 0)
                bttnRmv.Enabled = true;
        }

        private bool IsNPCIdValid()
        {
            return int.TryParse(txtNPCId.Text,out currentId);
        }

        private void bttnRmv_Click(object sender, EventArgs e)
        {
            if (lstBlacklist.SelectedItem != null)
            {
                Main.Settings.listSEFBlacklist.Remove((int)lstBlacklist.SelectedItem);
                lstBlacklist.Items.Remove(lstBlacklist.SelectedItem);
                Main.Settings.SEFBlacklist = Main.Settings.listSEFBlacklist.ToArray();
                Main.Settings.Save();
                if (lstBlacklist.Items.Count == 0)
                    bttnRmv.Enabled = false;
            }
        }
    }
}
