﻿using Styx;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Styx.CommonBot;
using HkM = Monkee.Core.Managers.HotkeyManager;
using OV = Monkee.Interface.GUI.frmOverlay;
using S = Monkee.Core.Spell;
using TM = Monkee.Core.Managers.TalentManager;
using SB = Monkee.Core.Helpers.SpellBook;
using U = Monkee.Core.Unit;
using L = Monkee.Core.Utilities.Log;
namespace Monkee.Rotation
{
    class Brewmaster : Rotation
    {

        public static async Task<bool> CombatCoRoutine()
        {

            //actions+=/blood_fury,if=energy<=40
            if (Me.Race == WoWRace.Orc && HkM.cooldownsOn && U.energy <=40 && await S.spellCast(SB.spellBloodFury))
                return true;
             //actions+=/berserking,if=energy<=40
            if (Me.Race == WoWRace.Troll && HkM.cooldownsOn && U.energy <= 40 && await S.spellCast(SB.spellBerserking))
                return true;
            //actions+=/arcane_torrent,if=energy<=40
            if (Me.Race == WoWRace.BloodElf && HkM.cooldownsOn && U.energy <=40 && await S.spellCast(SB.spellArcaneTorrent))
                return true;
            if (HkM.cooldownsOn && currentTarget.IsWithinMeleeRange && Me.Inventory.Equipped.Trinket1 != null && S.CanUseEquippedItem(Me.Inventory.Equipped.Trinket1))
            {
                if (Me.Inventory.Equipped.Trinket1.Use())
                    L.combatLog("Usings trinket 1");
                return true;
            }
            else if (HkM.cooldownsOn && currentTarget.IsWithinMeleeRange && Me.Inventory.Equipped.Trinket2 != null && S.CanUseEquippedItem(Me.Inventory.Equipped.Trinket2))
            {
                if (Me.Inventory.Equipped.Trinket2.Use())
                    L.combatLog("Usings trinket 2");
                return true;
            }
            //actions+=/chi_sphere,if=talent.power_strikes.enabled&buff.chi_sphere.react&chi<4
            
            //actions+=/chi_brew,if=talent.chi_brew.enabled&chi.max-chi>=2&buff.elusive_brew_stacks.stack<=10&((charges=1&recharge_time<5)|charges=2|(target.time_to_die<15&(cooldown.touch_of_death.remains>target.time_to_die|glyph.touch_of_death.enabled)))
            if (HkM.cooldownsOn &&  TM.chiBrew && (U.maxChi - U.chi) >= 2 && U.stacksEB <= 10 && ((U.chiBrewRecharge.charges == 1 && U.chiBrewRecharge.timeLeft < 5000) || U.chiBrewRecharge.charges == 2) && await S.spellCast(SB.spellChiBrew))
            {
                U.chiBrewRecharge.charges--;
                U.chiBrewRecharge.Start();
                return true;
            }
            //actions+=/chi_brew,if=(chi<1&stagger.heavy)|(chi<2&buff.shuffle.down)
            if (HkM.cooldownsOn &&  TM.chiBrew && (U.chi < 1 && U.auraExists(Me, SB.auraStaggerHeavy)) || (U.chi < 2 && !U.auraExists(Me, SB.auraShuffle)) && await S.spellCast(SB.spellChiBrew))
            {
                U.chiBrewRecharge.charges--;
                U.chiBrewRecharge.Start();
                return true;
            }
            //actions+=/gift_of_the_ox,if=buff.gift_of_the_ox.react&incoming_damage_1500ms
            //actions+=/diffuse_magic,if=incoming_damage_1500ms&buff.fortifying_brew.down
            //actions+=/dampen_harm,if=incoming_damage_1500ms&buff.fortifying_brew.down&buff.elusive_brew_activated.down
            //actions+=/fortifying_brew,if=incoming_damage_1500ms&(buff.dampen_harm.down|buff.diffuse_magic.down)&buff.elusive_brew_activated.down
            
            //actions+=/elusive_brew,if=buff.elusive_brew_stacks.react>=9&(buff.dampen_harm.down|buff.diffuse_magic.down)&buff.elusive_brew_activated.down
            if (U.auraStacks(Me, SB.auraElusiveBrewStacks) >= 9 && (!U.auraExists(Me, SB.auraDampenHarm) || !U.auraExists(Me, SB.auraDiffuseMagic)) && !U.auraExists(Me, SB.auraElusiveBrew) && await S.spellCast(SB.spellElusiveBrew))
                return true;
            //actions+=/invoke_xuen,if=talent.invoke_xuen.enabled&target.time_to_die>15&buff.shuffle.remains>=3&buff.serenity.down
            if (TM.invokeXuenTheWhiteTiger && HkM.cooldownsOn && U.auraTimeLeft(Me, SB.auraShuffle)>= 3000 && !U.auraExists(Me, SB.auraSerenity) && await S.spellCast(SB.spellInvokeXuen, false))
                return true;
            //actions+=/serenity,if=talent.serenity.enabled&cooldown.keg_smash.remains>6
            if (TM.serenity && HkM.cooldownsOn && S.cooldownTimeLeft(SB.spellKegSmash)>6000 && await S.spellCast(SB.spellSerenity))
                return true;
            //actions+=/potion,name=draenic_armor,if=(buff.fortifying_brew.down&(buff.dampen_harm.down|buff.diffuse_magic.down)&buff.elusive_brew_activated.down)
            
            
            //actions+=/call_action_list,name=tod,if=target.health.percent<10&target.time_to_die<8&cooldown.touch_of_death.remains=0&!glyph.touch_of_death.enabled
            if ((currentTarget.HealthPercent < 10 || currentTarget.CurrentHealth <= Me.MaxHealth) && S.cooldownTimeLeft(SB.spellTouchOfDeath) == 0)
                return await todRotation();
            //actions+=/call_action_list,name=st,if=active_enemies<3
            else if (!HkM.aoeOn || U.activeEnemies(Me.Location, 8+currentTarget.CombatReach).Count() < 3)
                return await stRotation();
            //actions+=/call_action_list,name=aoe,if=active_enemies>=3
            else if (HkM.aoeOn && U.activeEnemies(Me.Location, 8 + currentTarget.CombatReach).Count() >= 3)
                return await aoeRotation();
            return false;
        }

        private static async Task<bool> aoeRotation()
        {
            //actions.aoe=purifying_brew,if=stagger.heavy
            if(U.auraExists(Me, SB.auraStaggerHeavy) && await S.spellCast(SB.spellPurifyingBrew))
                return true;
            //actions.aoe+=/blackout_kick,if=buff.shuffle.down
            if (!U.auraExists(Me, SB.auraShuffle) && await S.spellCast(SB.spellBlackoutKick))
                return true;
            //actions.aoe+=/purifying_brew,if=buff.serenity.up
            if (U.serenityUp && (U.auraExists(Me, SB.auraStaggerLight) || U.auraExists(Me, SB.auraStaggerModerate) || U.auraExists(Me, SB.auraStaggerHeavy)) && await S.spellCast(SB.spellPurifyingBrew))
                return true;
            //actions.aoe+=/purifying_brew,if=!talent.chi_explosion.enabled&stagger.moderate&buff.shuffle.remains>=6
            if (!TM.chiExplosion && U.auraExists(Me, SB.auraStaggerModerate) && U.auraTimeLeft(Me, SB.auraShuffle) >= 6000 && await S.spellCast(SB.spellPurifyingBrew))
                return true;
            //actions.aoe+=/guard,if=(charges=1&recharge_time<5)|charges=2|target.time_to_die<15
            if (U.chi >= 2 && ((U.guardRecharge.charges == 1 && U.guardRecharge.timeLeft < 5000) || U.guardRecharge.charges == 2) && await S.spellCast(SB.spellGuard))
            {
                U.guardRecharge.charges--;
                U.guardRecharge.Start();
                return true;
            }
            //actions.aoe+=/guard,if=incoming_damage_10s>=health.max*0.5
            
            //actions.aoe+=/chi_brew,if=target.health.percent<10&cooldown.touch_of_death.remains=0&chi<=3&chi>=1&(buff.shuffle.remains>=6|target.time_to_die<buff.shuffle.remains)&!glyph.touch_of_death.enabled
            if (HkM.cooldownsOn && currentTarget.HealthPercent < 10 && S.cooldownTimeLeft(SB.spellTouchOfDeath) == 0 && U.chi <= 3 && U.chi >= 1 && (U.auraTimeLeft(Me, SB.auraShuffle) >= 6000 && await S.spellCast(SB.spellChiBrew))) //&!glyph.touch_of_death.enabled
            {
                U.chiBrewRecharge.charges--;
                U.chiBrewRecharge.Start();
                return true;
            }
            //actions.aoe+=/touch_of_death,if=target.health.percent<10&(buff.shuffle.remains>=6|target.time_to_die<=buff.shuffle.remains)&!glyph.touch_of_death.enabled
            if (currentTarget.HealthPercent < 10 && (U.auraTimeLeft(Me, SB.auraShuffle) >= 6000) && await S.spellCast(SB.spellTouchOfDeath))
                return true;
            //actions.aoe+=/breath_of_fire,if=(chi>=3|buff.serenity.up)&buff.shuffle.remains>=6&dot.breath_of_fire.remains<=2.4&!talent.chi_explosion.enabled
            if ((U.chi >= 3 || U.serenityUp) && U.auraTimeLeft(Me, SB.auraShuffle) >= 6000 && U.auraTimeLeft(currentTarget, SB.auraBreathFire) <= 2400 & !TM.chiExplosion && await S.spellCast(SB.spellBreathOfFire))
                return true;
            //actions.aoe+=/keg_smash,if=chi.max-chi>=1&!buff.serenity.remains
            if ((U.maxChi - U.chi) >= 1 && !U.serenityUp && await S.spellCast(SB.spellKegSmash))
                return true;
            //actions.aoe+=/touch_of_death,if=target.health.percent<10&glyph.touch_of_death.enabled
            if (currentTarget.HealthPercent < 10 && await S.spellCast(SB.spellTouchOfDeath))
                return true;
            //actions.aoe+=/rushing_jade_wind,if=chi.max-chi>=1&!buff.serenity.remains&talent.rushing_jade_wind.enabled
            if ((U.maxChi - U.chi) >= 1 && !U.serenityUp && TM.rushingJadeWind && await S.spellCast(SB.spellRushingJadeWind))
                return true;
            //actions.st+=/chi_burst,if=(energy+(energy.regen*gcd))<100
            if (U.energy * 1000 + (U.energyRegen * GCD) < 100000 && await S.spellCast(SB.spellChiBurst))
                return true;
            //actions.st+=/chi_wave,if=(energy+(energy.regen*gcd))<100
            if (U.energy * 1000 + (U.energyRegen * GCD) < 100000 && await S.spellCast(SB.spellChiWave))
                return true;
            //actions.st+=/zen_sphere,cycle_targets=1,if=talent.zen_sphere.enabled&!dot.zen_sphere.ticking&(energy+(energy.regen*gcd))<100
            if (!U.auraExists(Me, SB.spellZenSphere) && TM.zenSphere && U.energy * 1000 + (U.energy * 1000 * U.energyRegen * GCD) < 100000 && await S.spellCast(SB.spellZenSphere))
                return true;
            //actions.aoe+=/chi_explosion,if=chi>=4
            if (U.chi >= 4 && await S.spellCast(SB.spellChiExplosion))
                return true;
            //actions.aoe+=/blackout_kick,if=chi>=4
            if (U.chi >= 4 && await S.spellCast(SB.spellBlackoutKick))
                return true;
            //actions.aoe+=/blackout_kick,if=buff.shuffle.remains<=3&cooldown.keg_smash.remains>=gcd
            if (U.auraTimeLeft(Me, SB.auraShuffle)<=3000 && S.cooldownTimeLeft(SB.spellKegSmash)>=GCD && await S.spellCast(SB.spellBlackoutKick))
                return true;
            //actions.aoe+=/blackout_kick,if=buff.serenity.up
            if (U.serenityUp && await S.spellCast(SB.spellBlackoutKick))
                return true;
            //actions.aoe+=/expel_harm,if=chi.max-chi>=1&cooldown.keg_smash.remains>=gcd&(energy+(energy.regen*(cooldown.keg_smash.remains)))>=80
            if ((U.maxChi - U.chi) >= 1 && Me.HealthPercent < 95 && S.cooldownTimeLeft(SB.spellKegSmash) >= GCD && (U.energy * 1000 + (U.energyRegen * S.cooldownTimeLeft(SB.spellKegSmash))) >= 80000 && await S.spellCast(SB.spellExpelHarm))
                return true;
            //actions.aoe+=/jab,if=chi.max-chi>=1&cooldown.keg_smash.remains>=gcd&cooldown.expel_harm.remains>=gcd&(energy+(energy.regen*(cooldown.keg_smash.remains)))>=80
            if ((U.maxChi - U.chi) >= 1 && S.cooldownTimeLeft(SB.spellKegSmash) >= GCD && (U.energy * 1000 + (U.energyRegen * S.cooldownTimeLeft(SB.spellKegSmash))) >= 80000 && await S.spellCast(SB.spellJab))
                return true;
            //actions.aoe+=/tiger_palm
            if (U.auraTimeLeft(Me, SB.auraTigerPower) < 1500 && await S.spellCast(SB.spellTigerPalm))
                return true;
            return false;
        }

        private static async Task<bool> stRotation()
        {
            //actions.st=purifying_brew,if=!talent.chi_explosion.enabled&stagger.heavy
            if (!TM.chiExplosion && U.auraExists(Me, SB.auraStaggerHeavy) && await S.spellCast(SB.spellPurifyingBrew))
                return true;
            //actions.st+=/blackout_kick,if=buff.shuffle.down
            if (!U.auraExists(Me, SB.auraShuffle) && await S.spellCast(SB.spellBlackoutKick))
                return true;
            //actions.st+=/purifying_brew,if=buff.serenity.up
            if (U.serenityUp && (U.auraExists(Me, SB.auraStaggerLight)|| U.auraExists(Me, SB.auraStaggerModerate) ||  U.auraExists(Me, SB.auraStaggerHeavy)) && await S.spellCast(SB.spellPurifyingBrew))
                return true;
            //actions.st+=/purifying_brew,if=!talent.chi_explosion.enabled&stagger.moderate&buff.shuffle.remains>=6
            if (!TM.chiExplosion && U.auraExists(Me, SB.auraStaggerModerate) && U.auraTimeLeft(Me, SB.auraShuffle) >= 6000 && await S.spellCast(SB.spellPurifyingBrew))
                return true;
            //actions.st+=/guard,if=(charges=1&recharge_time<5)|charges=2|target.time_to_die<15
            if (U.chi >= 2 && ((U.guardRecharge.charges == 1 && U.guardRecharge.timeLeft < 5000) || U.guardRecharge.charges == 2) && await S.spellCast(SB.spellGuard))
            {
                U.guardRecharge.charges--;
                U.guardRecharge.Start();
                return true;
            }
            //actions.st+=/guard,if=incoming_damage_10s>=health.max*0.5
            
            //actions.st+=/chi_brew,if=target.health.percent<10&cooldown.touch_of_death.remains=0&chi<=3&chi>=1&(buff.shuffle.remains>=6|target.time_to_die<buff.shuffle.remains)&!glyph.touch_of_death.enabled
            if (HkM.cooldownsOn &&  currentTarget.HealthPercent < 10 && S.cooldownTimeLeft(SB.spellTouchOfDeath) == 0 && U.chi <= 3 && U.chi >= 1 && (U.auraTimeLeft(Me, SB.auraShuffle) >= 6000 && await S.spellCast(SB.spellChiBrew))) //&!glyph.touch_of_death.enabled
            {
                U.chiBrewRecharge.charges--;
                U.chiBrewRecharge.Start();
                return true;
            }
            //actions.st+=/touch_of_death,if=target.health.percent<10&(buff.shuffle.remains>=6|target.time_to_die<=buff.shuffle.remains)&!glyph.touch_of_death.enabled
            if (currentTarget.HealthPercent < 10 && (U.auraTimeLeft(Me, SB.auraShuffle) >= 6000) && await S.spellCast(SB.spellTouchOfDeath))
                return true;
            //actions.st+=/keg_smash,if=chi.max-chi>=1&!buff.serenity.remains
            if ((U.maxChi - U.chi) >= 1 && !U.serenityUp && await S.spellCast(SB.spellKegSmash))
                return true;
            //actions.st+=/touch_of_death,if=target.health.percent<10&glyph.touch_of_death.enabled
            if (currentTarget.HealthPercent < 10 && await S.spellCast(SB.spellTouchOfDeath))
                return true;
            //actions.st+=/chi_burst,if=(energy+(energy.regen*gcd))<100
            if (U.energy * 1000 + (U.energyRegen * GCD) < 100000 && await S.spellCast(SB.spellChiBurst))
                return true;
            //actions.st+=/chi_wave,if=(energy+(energy.regen*gcd))<100
            if (U.energy * 1000 + (U.energyRegen * GCD) < 100000 && await S.spellCast(SB.spellChiWave))
                return true;
            //actions.st+=/zen_sphere,cycle_targets=1,if=talent.zen_sphere.enabled&!dot.zen_sphere.ticking&(energy+(energy.regen*gcd))<100
            if (!U.auraExists(Me, SB.spellZenSphere) && TM.zenSphere && U.energy*1000 + (U.energy*1000 * U.energyRegen * GCD) < 100000 && await S.spellCast(SB.spellZenSphere))
                return true;
            //actions.st+=/chi_explosion,if=chi>=3
            if (U.chi >= 3 && await S.spellCast(SB.spellChiExplosion))
                return true;
            //actions.st+=/blackout_kick,if=chi>=4
            if (U.chi >= 4 && await S.spellCast(SB.spellBlackoutKick))
                return true;
            //actions.st+=/blackout_kick,if=buff.shuffle.remains<=3&cooldown.kegs_smash.remains>=gcd
            if (U.auraTimeLeft(Me, SB.auraShuffle)<=3 && S.cooldownTimeLeft(SB.spellKegSmash)>=GCD && await S.spellCast(SB.spellBlackoutKick))
                return true;
            //actions.st+=/blackout_kick,if=buff.serenity.up
            if (U.serenityUp && await S.spellCast(SB.spellBlackoutKick))
                return true;
            //actions.st+=/expel_harm,if=chi.max-chi>=1&cooldown.keg_smash.remains>=gcd&(energy+(energy.regen*(cooldown.keg_smash.remains)))>=80
            if ((U.maxChi -U.chi) >= 1 && Me.HealthPercent<95 && S.cooldownTimeLeft(SB.spellKegSmash)>=GCD &&(U.energy*1000 + (U.energyRegen * S.cooldownTimeLeft(SB.spellKegSmash))) >= 80000 && await S.spellCast(SB.spellExpelHarm))
                return true;
            //actions.st+=/jab,if=chi.max-chi>=1&cooldown.keg_smash.remains>=gcd&cooldown.expel_harm.remains>=gcd&(energy+(energy.regen*(cooldown.keg_smash.remains)))>=80
            if ((U.maxChi - U.chi) >= 1 && S.cooldownTimeLeft(SB.spellKegSmash) >= GCD  && (U.energy*1000 + (U.energyRegen * S.cooldownTimeLeft(SB.spellKegSmash))) >= 80000 && await S.spellCast(SB.spellJab))
                return true;
            //actions.st+=/tiger_palm
            if(await S.spellCast(SB.spellTigerPalm))
                return true;

            return false;
        }

        private static async Task<bool> todRotation()
        {
            
            //actions.tod+=/chi_brew,if=chi<3&talent.chi_brew.enabled
            if (U.chi < 3 && TM.chiBrew && await S.spellCast(SB.spellChiBrew))
                return true;
            //actions.tod+=/keg_smash,if=talent.chi_brew.enabled&chi<3
            if (U.chi < 3 && await S.spellCast(SB.spellKegSmash))
                return true;
            //actions.tod+=/expel_harm,if=chi<3&(cooldown.keg_smash.remains>target.time_to_die|((energy+(energy.regen*(cooldown.keg_smash.remains)))>=80)&cooldown.keg_smash.remains>=gcd)
            if (U.chi < 3 && (S.cooldownTimeLeft(SB.spellKegSmash) > 3000 || (U.energy*1000 + (U.energyRegen * (S.cooldownTimeLeft(SB.spellKegSmash)))) >= 80000) && S.cooldownTimeLeft(SB.spellKegSmash) >= GCD && await S.spellCast(SB.spellExpelHarm))
                return true;
            //actions.tod+=/jab,if=chi<3&(cooldown.keg_smash.remains>target.time_to_die|((energy+(energy.regen*(cooldown.keg_smash.remains)))>=80)&cooldown.keg_smash.remains>=gcd&cooldown.expel_harm.remains>=gcd)
            if (U.chi < 3 && (S.cooldownTimeLeft(SB.spellKegSmash) > 3000 || (U.energy*1000 + (U.energyRegen * (S.cooldownTimeLeft(SB.spellKegSmash)))) >= 80000) && S.cooldownTimeLeft(SB.spellKegSmash) >= GCD && S.cooldownTimeLeft(SB.spellExpelHarm)>=GCD && await S.spellCast(SB.spellJab))
                return true;
            //actions.tod=touch_of_death
            if (await S.spellCast(SB.spellTouchOfDeath))
                return true;
            //actions.tod+=/tiger_palm,if=talent.chi_brew.enabled&chi<3
            if (TM.chiBrew && U.chi < 3 && await S.spellCast(SB.spellTigerPalm))
                return true;
            return false;
        }
    }
}
