﻿using Styx;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using HkM = Monkee.Core.Managers.HotkeyManager;
using OV = Monkee.Interface.GUI.frmOverlay;
using S = Monkee.Core.Spell;
using TM = Monkee.Core.Managers.TalentManager;
using SB = Monkee.Core.Helpers.SpellBook;
using U = Monkee.Core.Unit;
using L = Monkee.Core.Utilities.Log;
using Styx.CommonBot;
using Singular;
using Singular.Helpers;
using Styx.CommonBot.Coroutines;
namespace Monkee.Rotation
{
    class Windwalker : Rotation
    {
        const int zenSphereLoctation = 15;

        #region [Method] - Combat Routine
        public static async Task<bool> CombatCoRoutine()
        {
            

            //actions+=/fortifying_brew,if=target.health.percent<10&cooldown.touch_of_death.remains=0&(glyph.touch_of_death.enabled|chi>=3)
            if ((currentTarget.HealthPercent < 10 || currentTarget.CurrentHealth <= Me.MaxHealth) && S.cooldownTimeLeft(SB.spellTouchOfDeath) == 0 && (U.chi >= 3) && await S.spellCast(SB.spellFortifyingBrew))
                return true;
            //actions+=/touch_of_death,if=target.health.percent<10&(glyph.touch_of_death.enabled|chi>=3)
            if ((currentTarget.HealthPercent < 10 || currentTarget.CurrentHealth <= Me.MaxHealth) && U.chi >= 3 && await S.spellCast(SB.spellTouchOfDeath))
                return true;
            //actions+=/invoke_xuen,if=talent.invoke_xuen.enabled&time>5
            if (TM.invokeXuenTheWhiteTiger && HkM.cooldownsOn && await S.spellCast(SB.spellInvokeXuen, false))
                return true;
            if (HkM.cooldownsOn && currentTarget.IsWithinMeleeRange && Me.Inventory.Equipped.Trinket1 != null && S.CanUseEquippedItem(Me.Inventory.Equipped.Trinket1))
            {
                if (Me.Inventory.Equipped.Trinket1.Use())
                    L.combatLog("Usings trinket 1");
                return true;
            }
            else if (HkM.cooldownsOn && currentTarget.IsWithinMeleeRange && Me.Inventory.Equipped.Trinket2 != null && S.CanUseEquippedItem(Me.Inventory.Equipped.Trinket2))
            {
                if (Me.Inventory.Equipped.Trinket2.Use())
                    L.combatLog("Usings trinket 2");
                return true;
            }

            //actions+=/storm_earth_and_fire_cancel, if=currenttarget.debuff.storm_earth_and_fire.up
            if (HkM.SEF)
            {
                IEnumerable<WoWUnit> illusions = U.activeSEFIllusions(Me.Location, 100);
                WoWUnit illusion1 = null;
                WoWUnit illusion2 = null;
                if (illusions.Count() == 2)
                {
                    illusion1 = illusions.First();
                    illusion2 = illusions.Last();
                }
                else if (illusions.Count() == 1)
                {
                    illusion1 = illusions.First();
                }
                if((illusion1 != null ? U.auraExists(currentTarget, SB.auraSEFOnUnit, illusion1.Guid, true) : false) || (illusion2 != null ? U.auraExists(currentTarget, SB.auraSEFOnUnit, illusion2.Guid, true) : false))
                    S.cancelAura(SB.auraSEFOnMe);
            }
            //actions+=/storm_earth_and_fire custom logic
            if (U.auraStacks(Me, SB.auraSEFOnMe) < 2 && HkM.SEF)
            {
                IEnumerable<WoWUnit> enemies = U.activeEnemies(Me.Location, Main.Settings.SEFRange).Where(
                    u => !Main.Settings.SEFBlacklist.Contains((int)u.Entry) 
                    && u != currentTarget 
                    && !U.auraExists(u, SB.auraSEFOnUnit) 
                    && u.InLineOfSight 
                    && (U.IsTrainingDummy(u) || (u.Combat && !U.IsCrowdControlled(u) && u.MaxHealth > Main.Settings.SEFMinHP))
                    ).OrderBy(u => u.Distance).ThenByDescending(u => u.MaxHealth);
                if (enemies.Count() > 0)
                {
                    WoWUnit u = enemies.FirstOrDefault();
                    return await S.spellCast(SB.spellSEF, u);
                }
            }

            //actions+=/call_action_list,name=opener,if=talent.serenity.enabled&talent.chi_brew.enabled&cooldown.fists_of_fury.up&time<20
            if (TM.serenity && TM.chiBrew && HkM.cooldownsOn && S.cooldownTimeLeft(SB.spellSerenity) == 0 && U.combatTime.ElapsedMilliseconds < 20000)
            {
                await openerRotation();
                return true;
            }
            //actions+=/blood_fury,if=buff.tigereye_brew_use.up|target.time_to_die<18
            if (Me.Race == WoWRace.Orc && HkM.cooldownsOn && U.tigerEyeBrewUp && await S.spellCast(SB.spellBloodFury))
                return true;
            //actions+=/berserking,if=buff.tigereye_brew_use.up|target.time_to_die<18
            else if (Me.Race == WoWRace.Troll && HkM.cooldownsOn && U.tigerEyeBrewUp && await S.spellCast(SB.spellBerserking))
                return true;
            //actions+=/arcane_torrent,if=chi.max-chi>=1&(buff.tigereye_brew_use.up|target.time_to_die<18)
            else if (Me.Race == WoWRace.BloodElf && HkM.cooldownsOn && (U.maxChi - U.chi) >= 1 && U.tigerEyeBrewUp && await S.spellCast(SB.spellArcaneTorrent))
                return true;
            //actions+=/chi_brew,if=chi.max-chi>=2&((charges=1&recharge_time<=10)|charges=2|target.time_to_die<charges*10)&buff.tigereye_brew.stack<=16
            if (TM.chiBrew && (Me.MaxChi - U.chi) >= 2 && HkM.cooldownsOn && (U.chiBrewRecharge.charges == 1 && U.chiBrewRecharge.timeLeft <= 10000 || U.chiBrewRecharge.charges == 2) && U.stacksTEB <= 16 && await S.spellCast(SB.spellChiBrew, false))
            {
                U.chiBrewRecharge.charges--;
                U.chiBrewRecharge.Start();
                return true;
            }
            //actions+=/tiger_palm,if=buff.tiger_power.remains<6.6
            if (U.auraTimeLeft(Me, SB.auraTigerPower) <= 3500 && U.chi >= 1 && await S.spellCast(SB.spellTigerPalm))
                return true;
            //actions+=/tigereye_brew,if=buff.tigereye_brew_use.down&buff.tigereye_brew.stack=20
            if (!U.tigerEyeBrewUp && U.stacksTEB == 20 && await S.spellCast(SB.spellTigerEyeBrew))
                return true;
            //actions+=/tigereye_brew,if=buff.tigereye_brew_use.down&buff.tigereye_brew.stack>=9&buff.serenity.up
            if (!U.tigerEyeBrewUp && U.stacksTEB >= 9 && TM.serenity && U.serenityUp && await S.spellCast(SB.spellTigerEyeBrew))
                return true;
            //actions+=/tigereye_brew,if=buff.tigereye_brew_use.down&buff.tigereye_brew.stack>=9&cooldown.fists_of_fury.up&chi>=3&debuff.rising_sun_kick.up&buff.tiger_power.up
            if (!U.tigerEyeBrewUp && U.stacksTEB >= 9 && S.cooldownTimeLeft(SB.spellFistsOfFury) == 0 && U.chi >= 3 && U.risingSunKick && U.tigerPower && await S.spellCast(SB.spellTigerEyeBrew))
                return true;
            //actions+=/tigereye_brew,if=talent.hurricane_strike.enabled&buff.tigereye_brew_use.down&buff.tigereye_brew.stack>=9&cooldown.hurricane_strike.up&chi>=3&debuff.rising_sun_kick.up&buff.tiger_power.up
            if (TM.hurricaneStrike && !U.tigerEyeBrewUp && U.stacksTEB >= 10 && SpellManager.CanCast(SB.spellHurricaneStrike) && U.chi >= 3 && U.risingSunKick && U.tigerPower && await S.spellCast(SB.spellTigerEyeBrew))
                return true;
            //actions+=/tigereye_brew,if=buff.tigereye_brew_use.down&chi>=2&(buff.tigereye_brew.stack>=16|target.time_to_die<40)&debuff.rising_sun_kick.up&buff.tiger_power.up
            if (!U.tigerEyeBrewUp && U.chi >= 2 && (U.stacksTEB >= 16 || currentTarget.HealthPercent < 10) && U.risingSunKick && U.tigerPower && await S.spellCast(SB.spellTigerEyeBrew))
                return true;
            //actions+=/rising_sun_kick,if=(debuff.rising_sun_kick.down|debuff.rising_sun_kick.remains<3)
            if (U.chi >= 2 && (!U.risingSunKick || U.auraTimeLeft(currentTarget, SB.auraRisingSunKick) < 3000) && await S.spellCast(SB.spellRisingSunKick))
                return true;
            //actions+=/serenity,if=chi>=2&buff.tiger_power.up&debuff.rising_sun_kick.up
            if (TM.serenity && currentTarget.IsWithinMeleeRange && HkM.cooldownsOn && U.chi >= 2 && U.tigerPower && U.risingSunKick && S.cooldownTimeLeft(SB.spellFistsOfFury) > 0 && await S.spellCast(SB.spellSerenity))
                return true;
            if (TM.chiExplosion && U.auraExists(Me, SB.auraComboBreaker_ChiExplosion) && await S.spellCast(SB.spellChiExplosion))
                return true;
            //actions+=/fists_of_fury,if=buff.tiger_power.remains>cast_time&debuff.rising_sun_kick.remains>cast_time&energy.time_to_max>cast_time&!buff.serenity.up
            //if (U.chi >= 3 && S.cooldownTimeLeft(SB.spellFistsOfFury) == 0 && U.auraTimeLeft(Me, SB.auraTigerPower) > S.getCastTime(SB.spellFistsOfFury) && U.auraTimeLeft(currentTarget, SB.auraRisingSunKick) > S.getCastTime(SB.spellFistsOfFury) && ((!U.serenityUp && S.cooldownTimeLeft(SB.spellSerenity) > 8000) || (U.serenityUp && U.auraTimeLeft(Me, SB.auraSerenity) < 1500) || !TM.serenity || !HkM.cooldownsOn) && await S.spellOnMoveCast(SB.spellFistsOfFury, currentTarget))
            if (U.chi >= 3 && S.cooldownTimeLeft(SB.spellFistsOfFury) == 0 && U.auraTimeLeft(Me, SB.auraTigerPower) > S.getCastTime(SB.spellFistsOfFury) && U.auraTimeLeft(currentTarget, SB.auraRisingSunKick) > S.getCastTime(SB.spellFistsOfFury) && !U.serenityUp && await S.spellOnMoveCast(SB.spellFistsOfFury, currentTarget)) 
                return true;

            //actions+=/hurricane_strike,if=energy.time_to_max>cast_time&buff.tiger_power.remains>cast_time&debuff.rising_sun_kick.remains>cast_time&buff.energizing_brew.down
            if (TM.hurricaneStrike && HkM.cooldownsOn && U.timeToMaxEnergy() > S.getCastTime(SB.spellHurricaneStrike) && U.auraTimeLeft(Me, SB.auraTigerPower) > S.getCastTime(SB.spellHurricaneStrike) && U.auraTimeLeft(currentTarget, SB.auraRisingSunKick) > S.getCastTime(SB.spellHurricaneStrike) && !U.auraExists(Me, SB.auraEnergizingBrew) && await S.spellCast(SB.spellHurricaneStrike))
                return true;

            //actions+=/energizing_brew,if=cooldown.fists_of_fury.remains>6&(!talent.serenity.enabled|(!buff.serenity.remains&cooldown.serenity.remains>4))&energy+energy.regen*gcd<50
            if (HkM.cooldownsOn && S.cooldownTimeLeft(SB.spellFistsOfFury) > 6000 && (!TM.serenity || (!U.serenityUp && S.cooldownTimeLeft(SB.spellSerenity) > 4000)) && U.energy < 35 && await S.spellCast(SB.spellEnergizingBrew))
                return true;
            //IEnumerable<WoWUnit> units = U.activeEnemies(Me.Location, 8);
            int countMe = U.activeEnemies(Me.Location, 8+currentTarget.CombatReach).Count();
            int countTarget = U.activeEnemies(currentTarget.Location, 8+currentTarget.CombatReach).Count();
            //actions+=/call_action_list,name=st,if=active_enemies<3&(level<100|!talent.chi_explosion.enabled)
            if ((countMe <= 3 || !HkM.aoeOn) && (Me.Level < 100 || !TM.chiExplosion))
                return await stRotation();
            //actions+=/call_action_list,name=st_chix,if=active_enemies=1&talent.chi_explosion.enabled
            else if ((countMe == 1 || !HkM.aoeOn) && TM.chiExplosion)
                return await stChiExRotation();
            //actions+=/call_action_list,name=cleave_chix,if=active_enemies=2&talent.chi_explosion.enabled
            else if ((HkM.aoeOn && countTarget == 2 || countTarget == 3) && TM.chiExplosion)
                return await cleaveChiExRotation();
            //actions+=/call_action_list,name=aoe,if=active_enemies>=3&!talent.rushing_jade_wind.enabled
            else if (HkM.aoeOn && countTarget > 3 && !TM.rushingJadeWind)
                return await aoeRotation();
            //actions+=/call_action_list,name=aoe_rjw,if=active_enemies>=3&talent.rushing_jade_wind.enabled
            else if (HkM.aoeOn && countTarget > 3 && TM.rushingJadeWind)
                return await aoeRJWRotation();
            return false;
        }

        private static async Task<bool> openerRotation()
        {
            //actions.opener+=/blood_fury,if=buff.tigereye_brew_use.up
            if (Me.Race == WoWRace.Orc && HkM.cooldownsOn && U.tigerEyeBrewUp && await S.spellCast(SB.spellBloodFury))
                return true;
            //actions.opener+=/berserking,if=buff.tigereye_brew_use.up
            else if (Me.Race == WoWRace.Troll && HkM.cooldownsOn && U.tigerEyeBrewUp && await S.spellCast(SB.spellBerserking))
                return true;
            //actions.opener+=/arcane_torrent,if=buff.tigereye_brew_use.up&chi.max-chi>=1
            else if (Me.Race == WoWRace.BloodElf && HkM.cooldownsOn && (U.maxChi - U.chi) >= 1 && U.tigerEyeBrewUp && await S.spellCast(SB.spellArcaneTorrent))
                return true;
            //actions.opener+=/tiger_palm,if=buff.tiger_power.remains<2
            if (U.chi >= 1 && U.auraTimeLeft(Me, SB.auraTigerPower) < 2000 && await S.spellCast(SB.spellTigerPalm))
                return true;
            //actions.opener+=/rising_sun_kick
            if (U.chi >= 2 && await S.spellCast(SB.spellRisingSunKick))
                return true;
            //actions.opener+=/chi_brew,if=chi.max-chi>=2
            if (HkM.cooldownsOn && await S.spellCast(SB.spellChiBrew))
            {
                U.chiBrewRecharge.charges--;
                U.chiBrewRecharge.Start();
                return true;
            }
            //actions.opener+=/jab,if=chi.max-chi>=2&!buff.serenity.up
            if (U.chi < 3 && U.energy >= 45 && S.cooldownTimeLeft(SB.spellFistsOfFury) == 0 && await S.spellCast(SB.spellJab))
                return true;
            //actions.opener=tigereye_brew,if=buff.tigereye_brew_use.down&buff.tigereye_brew.stack>=9
            if (await S.spellCast(SB.spellTigerEyeBrew) && !U.tigerEyeBrewUp && U.stacksTEB >= 9)
                return true;
            
            //actions.opener+=/fists_of_fury,if=buff.tiger_power.remains>cast_time&debuff.rising_sun_kick.remains>cast_time&buff.serenity.up&buff.serenity.remains<1.5
            if (U.chi >= 3 && await S.spellOnMoveCast(SB.spellFistsOfFury, currentTarget))
                return true;
            //actions.opener+=/jab,if=chi.max-chi>=2&!buff.serenity.up
            if (U.chi < 2 && U.energy >= 45 && !U.serenityUp && await S.spellCast(SB.spellJab))
                return true;
            //actions.opener+=/serenity,if=chi.max-chi<=2#
            if (TM.serenity && currentTarget.IsWithinMeleeRange && HkM.cooldownsOn && U.chi >= 2 && await S.spellCast(SB.spellSerenity))
                return true;

            return false;

        }

        private static async Task<bool> aoeRJWRotation()
        {
            //actions.aoe_rjw=chi_explosion,if=chi>=4&cooldown.fists_of_fury.remains>4
            if (U.chi >= 4 && S.cooldownTimeLeft(SB.spellFistsOfFury) > 4000 && await S.spellCast(SB.spellChiExplosion, false))
                return true;
            //actions.aoe_rjw+=/rushing_jade_wind
            if (U.energy >= 40 && await S.spellCast(SB.spellRushingJadeWind))
                return true;
            //actions.aoe_rjw+=/chi_wave,if=energy.time_to_max>2&buff.serenity.down
            if (TM.chiWave && U.timeToMaxEnergy() > 2000 && !U.serenityUp && await S.spellCast(SB.spellChiWave, false))
                return true;
            //actions.aoe+=/chi_burst,if=energy.time_to_max>2&buff.serenity.down
            if (TM.chiBurst && U.timeToMaxEnergy() > 2000 && !U.serenityUp && S.cooldownTimeLeft(SB.spellChiBurst) == 0)
            {
                WoWUnit u = Clusters.GetBestUnitForCluster(U.activeEnemies(Me.Location, 40), ClusterType.Radius, 5);
                if (u != null)
                {
                    u.Face();
                    await S.spellCast(SB.spellChiBurst, u);
                    currentTarget.Face();
                    return true;
                }
            }
            //actions.st+=/zen_sphere,cycle_targets=1,if=energy.time_to_max>2&!dot.zen_sphere.ticking
            WoWUnit player = null;
            try
            {
                if (StyxWoW.Me.FocusedUnit != null && !StyxWoW.Me.FocusedUnit.IsDead)
                    player = StyxWoW.Me.FocusedUnit;
                else
                    player = U.activeFriendPlayers(Me.Location, zenSphereLoctation).First();
            }
            catch { }
            //actions.st+=/zen_sphere,cycle_targets=1,if=energy.time_to_max>2&!dot.zen_sphere.ticking&buff.serenity.down
            if (TM.zenSphere && U.timeToMaxEnergy() > 2000 && !U.auraExists(Me, SB.spellZenSphere) && !U.serenityUp && await S.spellCast(SB.spellZenSphere))
                return true;
            else if (TM.zenSphere && player != null && U.timeToMaxEnergy() > 2000 && !U.auraExists(player, SB.spellZenSphere) && !U.serenityUp && await S.spellCast(SB.spellZenSphere, player))
                return true;
            //actions.aoe_rjw+=/blackout_kick,if=buff.combo_breaker_bok.react|buff.serenity.up
            if ((U.auraExists(Me, SB.auraComboBreaker_BlackoutKick) || U.serenityUp) && await S.spellCast(SB.spellBlackoutKick))
                return true;
            //actions.aoe_rjw+=/tiger_palm,if=buff.combo_breaker_tp.react&buff.combo_breaker_tp.remains<=2
            if (U.auraExists(Me, SB.auraComboBreaker_TigerPalm) && U.auraTimeLeft(Me, SB.auraComboBreaker_TigerPalm) <= 2000 && await S.spellCast(SB.spellTigerPalm))
                return true;
            //actions.aoe_rjw+=/blackout_kick,if=chi.max-chi<2&(cooldown.fists_of_fury.remains>3|!talent.rushing_jade_wind.enabled)
            if ((U.maxChi - U.chi) < 2 && (S.cooldownTimeLeft(SB.spellFistsOfFury) > 3000 || !TM.rushingJadeWind) && await S.spellCast(SB.spellBlackoutKick))
                return true;
            //actions.cleave_chix+=/chi_torpedo,if=energy.time_to_max>2
            //if (TM.chiTorpedo && U.timeToMaxEnergy() > 2000 && await S.spellCast(SB.spellChiTorpedo, false))
            //    return true;
            //actions.cleave_chix+=/expel_harm,if=chi.max-chi>=2&health.percent<95
            if (Me.HealthPercent < 40 && U.energy >= 40 && (U.maxChi - U.chi) >= 2 && await S.spellCast(SB.spellExpelHarm))
                return true;
            //actions.cleave_chix+=/jab,if=chi.max-chi>=2
            if ((U.maxChi - U.chi) >= 2 && U.energy >= 45 && await S.spellCast(SB.spellJab))
                return true;
            return false;
        }

        private static async Task<bool> cleaveChiExRotation()
        {
            //actions.cleave_chix=chi_explosion,if=chi>=4&cooldown.fists_of_fury.remains>4
            if (U.chi >= 4 && S.cooldownTimeLeft(SB.spellFistsOfFury) > 4000 && await S.spellCast(SB.spellChiExplosion, false))
                return true;
            //actions.cleave_chix+=/tiger_palm,if=buff.combo_breaker_tp.react&buff.combo_breaker_tp.remains<=2
            if (U.auraExists(Me, SB.auraComboBreaker_TigerPalm) && U.auraTimeLeft(Me, SB.auraComboBreaker_TigerPalm) <= 2000 && await S.spellCast(SB.spellTigerPalm))
                return true;
            //actions.aoe+=/chi_wave,if=energy.time_to_max>2&buff.serenity.down
            if (TM.chiWave && U.timeToMaxEnergy() > 2000 && !U.serenityUp && await S.spellCast(SB.spellChiWave, false))
                return true;
            //actions.aoe+=/chi_burst,if=energy.time_to_max>2&buff.serenity.down
            if (TM.chiBurst && U.timeToMaxEnergy() > 2000 && !U.serenityUp && S.cooldownTimeLeft(SB.spellChiBurst) == 0)
            {
                WoWUnit u = Clusters.GetBestUnitForCluster(U.activeEnemies(Me.Location, 40), ClusterType.Radius, 5);
                if (u != null)
                {
                    u.Face();
                    await S.spellCast(SB.spellChiBurst, u);
                    currentTarget.Face();
                    return true;
                }
            }
            //actions.st+=/zen_sphere,cycle_targets=1,if=energy.time_to_max>2&!dot.zen_sphere.ticking
            WoWUnit player = null;
            try
            {
                if (StyxWoW.Me.FocusedUnit != null && !StyxWoW.Me.FocusedUnit.IsDead)
                    player = StyxWoW.Me.FocusedUnit;
                else
                    player = U.activeFriendPlayers(Me.Location, zenSphereLoctation).First();
            }
            catch { }
            //actions.st+=/zen_sphere,cycle_targets=1,if=energy.time_to_max>2&!dot.zen_sphere.ticking&buff.serenity.down
            if (TM.zenSphere && U.timeToMaxEnergy() > 2000 && !U.auraExists(Me, SB.spellZenSphere) && !U.serenityUp && await S.spellCast(SB.spellZenSphere))
                return true;
            else if (TM.zenSphere && player != null && U.timeToMaxEnergy() > 2000 && !U.auraExists(player, SB.spellZenSphere) && !U.serenityUp && await S.spellCast(SB.spellZenSphere, player))
                return true;
            //actions.cleave_chix+=/chi_torpedo,if=energy.time_to_max>2
            //if (TM.chiTorpedo && U.timeToMaxEnergy() > 2000 && await S.spellCast(SB.spellChiTorpedo, false))
            //    return true;
            //actions.cleave_chix+=/expel_harm,if=chi.max-chi>=2&health.percent<95
            if (Me.HealthPercent < 40 && U.energy >= 40 && (U.maxChi - U.chi) >= 2 && await S.spellCast(SB.spellExpelHarm))
                return true;
            //actions.cleave_chix+=/jab,if=chi.max-chi>=2
            if ((U.maxChi - U.chi) >= 2 && U.energy >= 45 && await S.spellCast(SB.spellJab))
                return true;
            return false;
        }

        private static async Task<bool> aoeRotation()
        {
            //actions.aoe=chi_explosion,if=chi>=4&cooldown.fists_of_fury.remains>4
            if (U.chi >= 4  && S.cooldownTimeLeft(SB.spellFistsOfFury) > 4000 && await S.spellCast(SB.spellChiExplosion, false))
                return true;
            //actions.aoe+=/rising_sun_kick,if=chi=chi.max
            if (U.chi == U.maxChi && await S.spellCast(SB.spellRisingSunKick))
                return true;
            //actions.aoe+=/chi_wave,if=energy.time_to_max>2&buff.serenity.down
            if (TM.chiWave && U.timeToMaxEnergy() > 2000 && !U.serenityUp && await S.spellCast(SB.spellChiWave, false))
                return true;
            //actions.aoe+=/chi_burst,if=energy.time_to_max>2&buff.serenity.down
            if (TM.chiBurst && U.timeToMaxEnergy() > 2000 && !U.serenityUp && S.cooldownTimeLeft(SB.spellChiBurst) == 0)
            {
                WoWUnit u = Clusters.GetBestUnitForCluster(U.activeEnemies(Me.Location, 40), ClusterType.Radius, 5);
                if (u != null)
                {
                    u.Face();
                    await S.spellCast(SB.spellChiBurst, u);
                    currentTarget.Face();
                    return true;
                }
            }
            //actions.st+=/zen_sphere,cycle_targets=1,if=energy.time_to_max>2&!dot.zen_sphere.ticking
            WoWUnit player = null;
            try
            {
                if (StyxWoW.Me.FocusedUnit != null && !StyxWoW.Me.FocusedUnit.IsDead)
                    player = StyxWoW.Me.FocusedUnit;
                else
                    player = U.activeFriendPlayers(Me.Location, zenSphereLoctation).First();
            }
            catch { }
            //actions.st+=/zen_sphere,cycle_targets=1,if=energy.time_to_max>2&!dot.zen_sphere.ticking&buff.serenity.down
            if (TM.zenSphere && U.timeToMaxEnergy() > 2000 && !U.auraExists(Me, SB.spellZenSphere) && !U.serenityUp && await S.spellCast(SB.spellZenSphere))
                return true;
            else if (TM.zenSphere && player != null && U.timeToMaxEnergy() > 2000 && !U.auraExists(player, SB.spellZenSphere) && !U.serenityUp && await S.spellCast(SB.spellZenSphere, player))
                return true;
            //actions.aoe+=/chi_torpedo,if=energy.time_to_max>2
            //if (TM.chiTorpedo && U.timeToMaxEnergy() > 2000 && await S.spellCast(SB.spellChiTorpedo, false))
            //    return true;
            //actions.aoe+=/spinning_crane_kick
            if (U.energy >= 40 && await S.spellCast(SB.spellSpinningCraneKick))
                return true;
            if ((U.maxChi - U.chi) >= 2 && U.energy >= 45 && await S.spellCast(SB.spellJab))
                return true;
            return false;
        }

        private static async Task<bool> stChiExRotation()
        {
            //actions.st_chix=chi_explosion,if=chi>=2&buff.combo_breaker_ce.react&cooldown.fists_of_fury.remains>2
            if (U.chi >= 3 && !U.auraExists(Me, SB.auraComboBreaker_ChiExplosion) && (S.cooldownTimeLeft(SB.spellFistsOfFury) > 2000) && await S.spellCast(SB.spellChiExplosion))
                return true;
            //actions.st_chix+=/tiger_palm,if=buff.combo_breaker_tp.react&buff.combo_breaker_tp.remains<=2
            if (U.auraExists(Me, SB.auraComboBreaker_TigerPalm) && U.auraTimeLeft(Me, SB.auraComboBreaker_TigerPalm) <= 2000 && await S.spellCast(SB.spellTigerPalm))
                return true;
            //actions.st+=/chi_wave,if=energy.time_to_max>2&buff.serenity.down
            if (TM.chiWave && U.timeToMaxEnergy() > 2000 && !U.serenityUp && await S.spellCast(SB.spellChiWave, false))
                return true;
            WoWUnit player = null;
            try
            {
                if (StyxWoW.Me.FocusedUnit != null && !StyxWoW.Me.FocusedUnit.IsDead)
                    player = StyxWoW.Me.FocusedUnit;
                else
                    player = U.activeFriendPlayers(Me.Location, zenSphereLoctation).First();
            }
            catch { }
            //actions.st+=/zen_sphere,cycle_targets=1,if=energy.time_to_max>2&!dot.zen_sphere.ticking&buff.serenity.down
            if (TM.zenSphere && U.timeToMaxEnergy() > 2000 && !U.auraExists(Me, SB.spellZenSphere) && !U.serenityUp && await S.spellCast(SB.spellZenSphere))
                return true;
            else if (TM.zenSphere && player != null && U.timeToMaxEnergy() > 2000 && !U.auraExists(player, SB.spellZenSphere) && !U.serenityUp && await S.spellCast(SB.spellZenSphere, player))
                return true;
            //actions.st_chix+=/rising_sun_kick
            if (U.chi >= 2 && await S.spellCast(SB.spellRisingSunKick))
                return true;
            //actions.st_chix+=/tiger_palm,if=chi=4&!buff.combo_breaker_tp.react
            //if (U.chi == 4 && !U.auraExists(Me, SB.auraComboBreaker_TigerPalm) && await S.spellCast(SB.spellTigerPalm))
             //   return true;
            //actions.st_chix+=/chi_explosion,if=chi>=3&cooldown.fists_of_fury.remains>4
            //if (U.chi >= 3 && S.cooldownTimeLeft(SB.spellFistsOfFury) > 4000 && await S.spellCast(SB.spellChiExplosion))
            //    return true;
            //actions.st_chix+=/chi_torpedo,if=energy.time_to_max>2
            //if (TM.chiTorpedo && U.timeToMaxEnergy() > 2000 && await S.spellCast(SB.spellChiTorpedo, false))
            //    return true;
            //actions.st_chix+=/expel_harm,if=chi.max-chi>=2&health.percent<95
            if (Me.HealthPercent < 40 && U.energy >= 40 && (U.maxChi - U.chi) >= 2 && await S.spellCast(SB.spellExpelHarm))
                return true;
            //actions.st_chix+=/jab,if=chi.max-chi>=2
            if ((U.maxChi - U.chi) >= 2 && U.energy >= 45 && await S.spellCast(SB.spellJab))
                return true;
            //actions.st+=/chi_burst,if=energy.time_to_max>2&buff.serenity.down
            //if (TM.chiBurst && U.timeToMaxEnergy() > 2000 && !U.serenityUp && await S.spellCast(SB.spellChiBurst, false))
            //    return true;
            return false;
        }

        private static async Task<bool> stRotation()
        {
            //actions.st=rising_sun_kick
            if (U.chi >= 2 && await S.spellCast(SB.spellRisingSunKick))
                return true;
            //actions.st+=/blackout_kick,if=buff.combo_breaker_bok.react|buff.serenity.up
            if ((U.auraExists(Me, SB.auraComboBreaker_BlackoutKick) || U.serenityUp) && await S.spellCast(SB.spellBlackoutKick))
                return true;
            //actions.st+=/tiger_palm,if=buff.combo_breaker_tp.react&buff.combo_breaker_tp.remains<=2
            if (U.auraExists(Me, SB.auraComboBreaker_TigerPalm) && U.auraTimeLeft(Me, SB.auraComboBreaker_TigerPalm) <= 2000 && await S.spellCast(SB.spellTigerPalm))
                return true;
            //actions.st+=/chi_wave,if=energy.time_to_max>2&buff.serenity.down
            if (TM.chiWave && U.timeToMaxEnergy() > 2000 && !U.serenityUp && await S.spellCast(SB.spellChiWave, false))
                return true;
            //actions.st+=/zen_sphere,cycle_targets=1,if=energy.time_to_max>2&!dot.zen_sphere.ticking&buff.serenity.down
            WoWUnit player = null;
            try
            {
                if (StyxWoW.Me.FocusedUnit != null && !StyxWoW.Me.FocusedUnit.IsDead)
                    player = StyxWoW.Me.FocusedUnit;
                else
                    player = U.activeFriendPlayers(Me.Location, zenSphereLoctation).First();
            }
            catch { }
            //actions.st+=/zen_sphere,cycle_targets=1,if=energy.time_to_max>2&!dot.zen_sphere.ticking&buff.serenity.down
            if (TM.zenSphere && U.timeToMaxEnergy() > 2000 && !U.auraExists(Me, SB.spellZenSphere) && !U.serenityUp && await S.spellCast(SB.spellZenSphere))
                return true;
            else if (TM.zenSphere && player != null && U.timeToMaxEnergy() > 2000 && !U.auraExists(player, SB.spellZenSphere) && !U.serenityUp && await S.spellCast(SB.spellZenSphere, player))
                return true;
            //actions.st+=/chi_torpedo,if=energy.time_to_max>2&buff.serenity.down
            //if (TM.chiTorpedo && U.timeToMaxEnergy() > 2000 && !U.serenityUp && await S.spellCast(SB.spellChiTorpedo, false))
            //    return true;
            //actions.st+=/blackout_kick,if=chi.max-chi<2
            if ((Me.MaxChi - U.chi) < 2 && await S.spellCast(SB.spellBlackoutKick))
                return true;
            //actions.st+=/expel_harm,if=chi.max-chi>=2&health.percent<95
            if (Me.HealthPercent < 40 && U.energy >= 40 && (U.maxChi - U.chi) >= 2 && await S.spellCast(SB.spellExpelHarm))
                return true;
            //actions.st+=/jab,if=chi.max-chi>=2
            if ((U.maxChi - U.chi) >= 2 && U.energy >= 45 && await S.spellCast(SB.spellJab))
                return true;
            //actions.st+=/chi_burst,if=energy.time_to_max>2&buff.serenity.down
            //if (TM.chiBurst && U.timeToMaxEnergy() > 2000 && !U.serenityUp && await S.spellCast(SB.spellChiBurst, false))
            //    return true;
            return false;
        }
        #endregion
    }
}
